SystemOrganization addCategory: #'Math-Tests-Accuracy'!

Accuracy subclass: #AccuracyTestExample
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-Accuracy'!

!AccuracyTestExample commentStamp: 'WernerKassens 9/11/2014 09:38' prior: 0!
used for tests. if you want to see how to subclass Accuracy, you only need to look at initialize, initializeXXX and checkXXX, the rest is only for AccuracyTest.
if you want to see its output, just 'print it':
AccuracyTestExample new run.
!

!AccuracyTestExample methodsFor: 'tests' stamp: 'WernerKassens 9/11/2014 13:17'!
checkAaa
self argument first ifTrue:[^#(1 1)].
^{4 +(0.4 * Random new next) . 2}! !

!AccuracyTestExample methodsFor: 'tests' stamp: 'WernerKassens 9/2/2014 12:16'!
checkBbb
^self argument first size +self parameter first ! !

!AccuracyTestExample methodsFor: 'tests' stamp: 'WernerKassens 9/2/2014 22:01'!
checkCcc
^self argument first +(0.01*self parameter first).! !

!AccuracyTestExample methodsFor: 'tests' stamp: 'WernerKassens 8/31/2014 12:23'!
checkDdd
^{2 .3 }asOrderedCollection ! !

!AccuracyTestExample methodsFor: 'tests' stamp: 'WernerKassens 8/5/2014 15:29'!
checkEee
^{self parameter first .3 }! !

!AccuracyTestExample methodsFor: 'tests' stamp: 'wernerkassens 9/13/2014 18:17'!
checkFff
^{0. 0. 1. 0. Float nan}! !

!AccuracyTestExample methodsFor: 'private' stamp: 'WernerKassens 9/1/2014 18:34'!
count
^count! !

!AccuracyTestExample methodsFor: 'initialize-release' stamp: 'WernerKassens 9/2/2014 12:30'!
initialize 
"this is always necessarily the first thing:"
super initialize .
"this is only for testSetup:"
count:=0.
"now you can set defaults:"
self result: #(#(2)#(3)).
self argument: #(#('a') #('AG')).
self parameter: #(#(1) #(3))
! !

!AccuracyTestExample methodsFor: 'initialize-release' stamp: 'WernerKassens 8/5/2014 16:50'!
initializeAaa
"this overrides defaults in #initialize:"
self result: #(#(5 3) #(4 4)).
self argument: #(#(false) #(true)).
self parameter: #(#(1 2) #(3 2.8888))! !

!AccuracyTestExample methodsFor: 'initialize-release' stamp: 'WernerKassens 9/2/2014 18:39'!
initializeCcc
"this overrides defaults in initialize"
self result: #((1)(1)(1)).
self argument: #((1)(1.1)(0.9)).! !

!AccuracyTestExample methodsFor: 'initialize-release' stamp: 'WernerKassens 8/13/2014 22:33'!
initializeDdd
"this overrides defaults in initialize"
self result: #(1.1 2.2).
self argument: #()."necessary since otherwise the default values defined in #initialize would be used"
self parameter: #().! !

!AccuracyTestExample methodsFor: 'initialize-release' stamp: 'WernerKassens 8/13/2014 22:29'!
initializeEee
"this overrides defaults in initialize"
self result: #(#(1.1 2.2) #(1 3)).
! !

!AccuracyTestExample methodsFor: 'initialize-release' stamp: 'wernerkassens 9/20/2014 09:32'!
initializeFff
"this overrides defaults in initialize"
self result: #(0 1 0 -2 3).
self argument: nil.
self parameter:nil.! !

!AccuracyTestExample methodsFor: 'running' stamp: 'WernerKassens 9/2/2014 12:12'!
setUp 
count :=count+1.! !

!AccuracyTestExample methodsFor: 'running' stamp: 'WernerKassens 9/2/2014 12:12'!
tearDown
count :=count-(1/5).! !

!AccuracyTestExample methodsFor: 'private' stamp: 'WernerKassens 8/1/2014 15:39'!
testArgumentError
self argument: #(#(1) #(2)).! !

!AccuracyTestExample methodsFor: 'private' stamp: 'WernerKassens 8/1/2014 15:33'!
testGetterAaa
^{ self parameter .self argument.self resultsAt: 'Aaa'.self numberOfDifferentParametersAt: 'Aaa'.self numberOfDifferentResultsAt:'Aaa'}! !

!AccuracyTestExample methodsFor: 'private' stamp: 'WernerKassens 8/13/2014 17:12'!
testGetterBbb
^{ self parameter .self argument.self resultsAt: 'Bbb'.self numberOfDifferentParametersAt: 'Bbb'.self numberOfDifferentResultsAt:'Bbb'}! !

!AccuracyTestExample methodsFor: 'private' stamp: 'WernerKassens 8/1/2014 15:40'!
testParameterError
self parameter:  #(#(1) #(2)).! !

!AccuracyTestExample methodsFor: 'private' stamp: 'WernerKassens 8/1/2014 15:37'!
testResultError
self result:#(1).! !

TestCase subclass: #AccuracyTest
	instanceVariableNames: 'a dp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Tests-Accuracy'!

!AccuracyTest commentStamp: '<historical>' prior: 0!
AccuracyTest uses AccuracyTestExample!

!AccuracyTest methodsFor: 'initialize-release' stamp: 'WernerKassens 8/10/2014 16:35'!
initialize 
super initialize .
dp:=AccuracyTestExample decimalPlaces .
! !

!AccuracyTest methodsFor: 'running' stamp: 'WernerKassens 8/10/2014 16:45'!
setUp 
a:=AccuracyTestExample new.
AccuracyTestExample decimalPlaces: 3.! !

!AccuracyTest methodsFor: 'running' stamp: 'WernerKassens 8/10/2014 16:47'!
tearDown 
AccuracyTestExample decimalPlaces:dp .
! !

!AccuracyTest methodsFor: 'tests' stamp: 'WernerKassens 9/2/2014 21:57'!
testArgumentAt
	self assert: (a argumentAt: 'Aaa') = #(#(false) #(true)).
	self assert: (a argumentAt: 'Bbb') = #(#('a') #('AG')).
	self assert: (a argumentAt: 'Ddd') isNil.
	self assert: (a argumentAt: 'Ccc') = #(#(1) #(1.1) #(0.9))! !

!AccuracyTest methodsFor: 'tests' stamp: 'WernerKassens 8/1/2014 15:42'!
testArgumentError
self should: [a testArgumentError ]raise: Error! !

!AccuracyTest methodsFor: 'tests' stamp: 'WernerKassens 9/4/2014 16:41'!
testAsArray
	self assert: (a asArray: 'bla') = #('bla').
	self assert: (a asArray: #('bla'))= #('bla').
	self assert: (a asArray: #('bla')asOrderedCollection )= #('bla').! !

!AccuracyTest methodsFor: 'tests' stamp: 'WernerKassens 8/13/2014 18:03'!
testCalcDeviationsInMax
| r c |
c :=#(#(1 2 3)#(2 3 6) ).
r :={ (3/2) . (9/4). 4}.
	self assert: (a calcDeviations: r in: c max: false) = { (-100/3)asFloat. (-100/9)asFloat. -25}.
	self assert: (a calcDeviations: r in: c max: true) = { (100/3)asFloat. (100/3)asFloat. 50}.! !

!AccuracyTest methodsFor: 'tests' stamp: 'WernerKassens 8/13/2014 16:57'!
testCalcErrorOfRealResult
	self assert: (a calcErrorOf: 0.7 realResult:0.7 ) = 0.
	self assert: (a calcErrorOf: 0.7 realResult:0.0 ) = -100 .
	self assert: (a calcErrorOf: 1/4 realResult:1/2 ) = 100.
	self assert: (a calcErrorOf: 0.0 realResult:7 ) = Float infinity.
	self assert: (a calcErrorOf: 0.0 realResult:0 ) = 0.
	self assert: (a calcErrorOf: 0.0 realResult:(-1/7) ) = Float infinity negated.

! !

!AccuracyTest methodsFor: 'tests' stamp: 'wernerkassens 9/13/2014 18:42'!
testDataTree
	| s |
	a run.
	self assert: (a dataTree atPath: #('iterations')) = 1.
	self assert: (a dataTree atPath: #('names' 'data')) = #('Aaa' 'Bbb' 'Ccc' 'Ddd' 'Eee' 'Fff').
	self assert: (a dataTree atPath: #('names' 'Aaa' #(1 2) #(4 4)))= (KeyedTree new
						at: 'arguments' put: true;
						at: 'data' put: #(#(1 1));
						at: 'error' put: #(300.0 300.0);
						at: 'expected result' put: #(4 4);
						at: 'result' put: #(1 1);
						at: 'type' put: 'result';
						yourself).
	self assert: (a dataTree atPath: #('names' 'Aaa' 'data')) = #(#(1 2) #(3 2.8888)).
	self assert: (a dataTree atPath: #('names' 'Bbb' #(3) 'data')) = #(#(2) #(3)).
	s:=a dataTree atPath: #('names' 'Ccc' #(3)).
	self assert: s keys size= 5.
	s:=a dataTree atPath: #('names' 'Fff' 'error').
	self assert: (s copyFrom: 1 to: 4) = {0.(Float infinity).-100.0.(Float infinity negated)}.
	self assert: (s at:5) isNaN .! !

!AccuracyTest methodsFor: 'tests' stamp: 'WernerKassens 8/30/2014 14:25'!
testDecimalPlaces
	self assert: a class decimalPlaces=3.
	a class decimalPlaces: 2.
	self assert: a class decimalPlaces=2.! !

!AccuracyTest methodsFor: 'tests' stamp: 'WernerKassens 8/31/2014 10:50'!
testExtractFromResultsWhichOnlyOne
self assert: (a extractFromResults: #( 'bla' 'blah') which: 2 onlyOne: false)='blah'.
self assert: (a testGetterAaa second) = #(true).
self assert: (a extractFromResults: #( 'bla' 'blah') which: 1 onlyOne: true)=#('bla' 'blah').
self assert: (a testGetterAaa second) = #(#(false) #(true)).
! !

!AccuracyTest methodsFor: 'tests' stamp: 'WernerKassens 8/14/2014 08:40'!
testExtremeCollectionmax
|c|
c:=#(4 4 2).
	self assert: (a extremeCollection: c max: true) = {Float infinity negated}.
	self assert: (a extremeCollection: c max: false) = {Float infinity }.
	self assert: (a extremeCollection: {c} max: false) = {Float infinity .Float infinity .Float infinity .}! !

!AccuracyTest methodsFor: 'tests' stamp: 'WernerKassens 8/30/2014 11:17'!
testFormat
self assert: ((a format: #(1 'rez' 1.8899))= #('1.0' 'rez' '1.89') ).
self assert: ((a format: #(10 100 0.18899 0.018899))= #('10.0' '1.0e2' '0.189' '1.89e-2') ).
self assert:((a format: Float infinity )=#('Infinity')).
self assert:((a format: (0 - Float infinity) )=#('-Infinity'))
! !

!AccuracyTest methodsFor: 'tests' stamp: 'WernerKassens 9/2/2014 22:50'!
testFormatTypePostfix
|r|
r:=a format: #(1 'rez' 1.8899) type:'x' postfix:'%%'.
self assert: r contents= 'x: 1.0%% , rez%% , 1.89%% ' .
r:=a format: #(1.8899 true) type: '' postfix:nil.
self assert: r contents= 'x: 1.0%% , rez%% , 1.89%% : 1.89 , true ' .
! !

!AccuracyTest methodsFor: 'tests' stamp: 'WernerKassens 8/30/2014 11:52'!
testFormatTypePostfixTree
|t|
t:=KeyedTree new.
self assert: ((a format: #(100.0 'rez' 0.18899) type:'x' postfix:'%%' tree: t) contents=  'x: 1.0e2%% , rez%% , 0.189%% ' ).
self assert:(t=(KeyedTree new at:'x' put:#(100.0 'rez' 0.18899);yourself) ).
! !

!AccuracyTest methodsFor: 'tests' stamp: 'WernerKassens 9/1/2014 21:52'!
testGetters
|r|
r:=a testGetterAaa.
self assert:(r = #(#(#(1 2) #(3 2.8888)) #(#(false) #(true)) #(#(5 3) #(4 4)) 2 2)).
r:=a testGetterBbb.
self assert:(r = #(#(#(1) #(3)) #(#('a') #('AG')) #(#(2) #(3)) 2 2)).
 #(#(#(1) #(3)) #(#(1) #(2)) #(#(2) #(3)) 2 2)! !

!AccuracyTest methodsFor: 'tests' stamp: 'WernerKassens 8/1/2014 16:03'!
testIfSeveralterations
a iterations: 2.
self assert: ((a ifSeveralterations:[1])= 1 ).
a iterations: 1.
self assert: ((a ifSeveralterations:[1])= a ).
! !

!AccuracyTest methodsFor: 'tests' stamp: 'WernerKassens 9/11/2014 09:20'!
testIterations
	| s d|
	a iterations: 2; run.
	d := a dataTree at: 'names'.
	s := (d atPath: #('Aaa' #(1 2) #(5 3) '+dev')) first negated.
	self assert: ((d atPath: #('Aaa' #(1 2) #(5 3) '-dev')) first closeTo: s).
	s := d atPath: #('Aaa' #(3 2.8888) #(5 3) 'standard deviation').
	self assert: s first > 0.
	self assert: s second = 0.
	self assert: (d atPath: #('Ddd' 'data')) = #((2 3) (2 3)).
	s:=d atPath: #('Ddd' 'error').
	self assert: (s first closeTo: -45).
	self assert: (s second closeTo: -26.6666667).! !

!AccuracyTest methodsFor: 'tests' stamp: 'WernerKassens 8/30/2014 18:21'!
testNumberOfDifferentParametersAt
	self assert: (a numberOfDifferentParametersAt: 'Aaa') =2.
	self assert: (a numberOfDifferentParametersAt: 'Ccc') =2.
	self assert: (a numberOfDifferentParametersAt: 'Ddd') =1.
	self assert: (a numberOfDifferentParametersAt: 'Fff') =1.
! !

!AccuracyTest methodsFor: 'tests' stamp: 'WernerKassens 9/2/2014 21:57'!
testNumberOfDifferentResultsAt
	self assert: (a numberOfDifferentResultsAt: 'Aaa') =2.
	self assert: (a numberOfDifferentResultsAt: 'Bbb') =2.
	self assert: (a numberOfDifferentResultsAt: 'Ccc') =3.
	self assert: (a numberOfDifferentResultsAt: 'Ddd') =1.
	self assert: (a numberOfDifferentResultsAt: 'Eee') =2.
! !

!AccuracyTest methodsFor: 'tests' stamp: 'WernerKassens 8/21/2014 15:39'!
testParameterAt
	self assert: (a parameterAt: 'Aaa') = #(#(1 2) #(3 2.8888)).
	self assert: (a parameterAt: 'Bbb') = #(#(1) #(3)).
	self assert: (a parameterAt: 'Ddd') isNil.
	self assert: (a parameterAt: 'Fff') isNil! !

!AccuracyTest methodsFor: 'tests' stamp: 'WernerKassens 8/1/2014 15:42'!
testParameterError
self should: [a testParameterError ]raise: Error! !

!AccuracyTest methodsFor: 'tests' stamp: 'WernerKassens 9/10/2014 22:15'!
testPrintOn
|s|
s:= WriteStream on: String new.
a printOn: s.
self assert:(s contents ='an AccuracyTestExample ()').
s reset.
a run.
a printOn: s.
self assert: (s contents beginsWith: 'an AccuracyTestExample (
Report for: AccuracyTestExample')! !

!AccuracyTest methodsFor: 'tests' stamp: 'WernerKassens 9/11/2014 09:14'!
testReport
self assert:  a report = ''.
a run.
self assert: (a report beginsWith: 'Report for: AccuracyTestExample')! !

!AccuracyTest methodsFor: 'tests' stamp: 'WernerKassens 8/1/2014 15:41'!
testResultError
self should: [a testResultError ]raise: Error! !

!AccuracyTest methodsFor: 'tests' stamp: 'wernerkassens 9/13/2014 18:23'!
testResultsKeyForAtPosition
	self assert:( a resultsKeyFor: 'Aaa' AtPosition:2) = #(4 4) .
	self assert: (a resultsKeyFor: 'Bbb' AtPosition:1) = #(2). 
	a run.
	self assert: (a dataTree atPath: {'names'. 'Ccc'. #(1).a resultsKeyFor: 'Ccc' AtPosition:1.'arguments'}) = 1. 
	self assert: (a dataTree atPath: {'names'. 'Ccc'. #(1).a resultsKeyFor: 'Ccc' AtPosition:3.'arguments'}) = 0.9.
	self assert: (a resultsKeyFor: 'Eee' AtPosition:2) = #(1 3).
	self assert: (a resultsKeyFor: 'Fff' AtPosition:1) = #(0 1 0 -2 3) ! !

!AccuracyTest methodsFor: 'tests' stamp: 'WernerKassens 9/14/2014 10:13'!
testRun
	a run.
	a run: 'Bbb'.
	self assert: (a dataTree atPath: #('names' 'data')) = #('Bbb').
	self assert: (a report beginsWith:  'Report for: AccuracyTestExample
test Bbb').
	a run: #('Ccc' 'Eee').
	self assert: (a dataTree atPath: #('names' 'data')) = #('Ccc' 'Eee').
! !

!AccuracyTest methodsFor: 'tests' stamp: 'WernerKassens 9/2/2014 12:12'!
testSetUp
	self assert: a count = 0.
	a performCheck: 'Fff'.
	self assert: a count = (4/5).
	a iterations:3.
	a performCheck: 'Ccc'.
	self assert: a count = (16/5).! !

!AccuracyTest methodsFor: 'tests' stamp: 'WernerKassens 8/31/2014 10:12'!
testTreeTypeData
|aTree|
aTree := KeyedTree new.
self assert: (a tree: aTree type: 'aa' data:'bb') = aTree.
self assert: aTree = (KeyedTree new at:'data'put:'bb'; at: 'type'put:'aa'; yourself) .
! !

!AccuracyTest methodsFor: 'tests' stamp: 'wernerkassens 9/13/2014 18:38'!
testperformCheck
|b|
	a extractFromResults: 'bla' which: 2 onlyOne: false."for setting numberOfResults"
	self assert: (a performCheck: 'Aaa') =  #(#(1 1)).
	a extractFromResults: 'bla' which: 1 onlyOne: true."for setting numberOfResults"
	a iterations:3.
	b:=a performCheck: 'Fff'.
	self assert: (b first first =  0).
	self assert: (b second third =  1).
	self assert: (b third at:5) isNaN .! !
